/**
 * Bundle of @devexpress/dx-react-chart-bootstrap4
 * Generated: 2018-10-04
 * Version: 1.8.0
 * License: https://js.devexpress.com/Licensing
 */

import { withPatchedProps, Chart, withComponents, Palette, Legend, Title, AreaSeries, LineSeries, SplineSeries, Grid, ValueGrid, ArgumentGrid, Axis, ValueAxis, ArgumentAxis } from '@devexpress/dx-react-chart';
export { BarSeries, PieSeries, ScatterSeries } from '@devexpress/dx-react-chart';
import classNames from 'classnames';
import { createElement, PureComponent } from 'react';
import { node, oneOfType, string, number } from 'prop-types';

var classCallCheck = function (instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
};

var createClass = function () {
  function defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  return function (Constructor, protoProps, staticProps) {
    if (protoProps) defineProperties(Constructor.prototype, protoProps);
    if (staticProps) defineProperties(Constructor, staticProps);
    return Constructor;
  };
}();

var _extends = Object.assign || function (target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i];

    for (var key in source) {
      if (Object.prototype.hasOwnProperty.call(source, key)) {
        target[key] = source[key];
      }
    }
  }

  return target;
};

var inherits = function (subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      enumerable: false,
      writable: true,
      configurable: true
    }
  });
  if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
};

var objectWithoutProperties = function (obj, keys) {
  var target = {};

  for (var i in obj) {
    if (keys.indexOf(i) >= 0) continue;
    if (!Object.prototype.hasOwnProperty.call(obj, i)) continue;
    target[i] = obj[i];
  }

  return target;
};

var possibleConstructorReturn = function (self, call) {
  if (!self) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return call && (typeof call === "object" || typeof call === "function") ? call : self;
};

var withClassName = function withClassName() {
  for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
    args[_key] = arguments[_key];
  }

  var setClassName = function setClassName(_ref) {
    var className = _ref.className,
        restProps = objectWithoutProperties(_ref, ['className']);
    return _extends({
      className: classNames.apply(undefined, args.concat([className]))
    }, restProps);
  };
  return withPatchedProps(setClassName);
};

var Root = withClassName('dx-c-bs4-container')(Chart.Root);

var palette = ['#0070ff', '#d72e3d', '#249d3d', '#ffb90c', '#1698af', '#616a72'];

var ChartWithPalette = function ChartWithPalette(_ref) {
  var children = _ref.children,
      props = objectWithoutProperties(_ref, ['children']);
  return createElement(
    Chart,
    props,
    createElement(Palette, { scheme: palette }),
    children
  );
};

ChartWithPalette.components = Chart.components;

process.env.NODE_ENV !== "production" ? ChartWithPalette.propTypes = {
  children: node.isRequired
} : void 0;

var Chart$1 = withComponents({ Root: Root })(ChartWithPalette);

var Root$1 = withClassName('list-group', 'py-3')(function (props) {
  return createElement('ul', props);
});

var Label = withClassName('text-body', 'pl-2', 'pr-2')(function (_ref) {
  var text = _ref.text,
      restProps = objectWithoutProperties(_ref, ['text']);
  return createElement(
    'span',
    restProps,
    text
  );
});

var Item = withClassName('d-flex', 'list-group-item', 'border-0', 'py-1', 'px-4', 'align-items-center')(function (props) {
  return createElement('li', props);
});

var Legend$1 = withComponents({
  Root: Root$1, Item: Item, Label: Label
})(Legend);

var Text = function (_React$PureComponent) {
  inherits(Text, _React$PureComponent);

  function Text() {
    classCallCheck(this, Text);
    return possibleConstructorReturn(this, (Text.__proto__ || Object.getPrototypeOf(Text)).apply(this, arguments));
  }

  createClass(Text, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          text = _props.text,
          restProps = objectWithoutProperties(_props, ['text']);

      return createElement(
        'h3',
        restProps,
        text
      );
    }
  }]);
  return Text;
}(PureComponent);

process.env.NODE_ENV !== "production" ? Text.propTypes = {
  text: oneOfType([string, number]).isRequired
} : void 0;

var Title$1 = withComponents({ Text: Text })(Title);

var Area = withClassName('dx-c-bs4-series-opacity')(AreaSeries.Path);

var AreaSeries$1 = withComponents({ Path: Area })(AreaSeries);

var Path = withClassName('dx-c-bs4-fill-none', 'dx-c-bs4-series-path')(LineSeries.Path);

var LineSeries$1 = withComponents({ Path: Path })(LineSeries);

var SplineSeries$1 = withComponents({ Path: Path })(SplineSeries);

var Line = withClassName('dx-c-bs4-stroke-current-color', 'dx-c-bs4-crisp-edges', 'dx-c-bs4-axis-opacity')(Grid.Line);

var ValueGrid$1 = withComponents({ Line: Line })(ValueGrid);

var ArgumentGrid$1 = withComponents({ Line: Line })(ArgumentGrid);

var Root$2 = withClassName('dx-c-bs4-crisp-edges')(Axis.Root);

var Tick = withClassName('dx-c-bs4-stroke-current-color', 'dx-c-bs4-crisp-edges', 'dx-c-bs4-axis-opacity')(Axis.Tick);

var Label$1 = withClassName('dx-c-bs4-fill-current-color', 'dx-c-bs4-axis-label', 'text-muted')(Axis.Label);

var Line$1 = withClassName('dx-c-bs4-stroke-current-color', 'dx-c-bs4-axis-opacity')(Axis.Line);

var ValueAxis$1 = withComponents({
  Root: Root$2, Tick: Tick, Label: Label$1, Line: Line$1
})(ValueAxis);

var ArgumentAxis$1 = withComponents({
  Root: Root$2, Tick: Tick, Label: Label$1, Line: Line$1
})(ArgumentAxis);

export { Chart$1 as Chart, Legend$1 as Legend, Title$1 as Title, AreaSeries$1 as AreaSeries, LineSeries$1 as LineSeries, SplineSeries$1 as SplineSeries, ValueGrid$1 as ValueGrid, ArgumentGrid$1 as ArgumentGrid, ValueAxis$1 as ValueAxis, ArgumentAxis$1 as ArgumentAxis };
//# sourceMappingURL=dx-react-chart-bootstrap4.es.js.map
